package example.energy;

import schedframe.resources.ResourceStatus;
import schedframe.resources.computing.Processor;
import schedframe.resources.computing.profiles.energy.ResourceEvent;
import schedframe.resources.computing.profiles.energy.power.StandardPowerStateName;
import schedframe.resources.devices.PhysicalResource;
import schedframe.scheduling.manager.tasks.JobRegistry;

public class ProcessorEnergyEstimationPlugin extends BaseEnergyEstimationPlugin  {

	public double estimatePowerConsumption(ResourceEvent event, JobRegistry jobRegistry,
			PhysicalResource resource) {
		double powerConsumption = 0;

		Processor cpu = (Processor)resource;
		if(resource.getPowerInterface().getPowerState().equals(StandardPowerStateName.OFF))
			powerConsumption = 0;
		else {
			if(resource.getStatus() == ResourceStatus.BUSY){
				try {

					powerConsumption = cpu.getPowerInterface().getPowerConsumption(cpu.getPowerInterface().getPState());
				} catch (NoSuchFieldException e) {
					try {
						if(cpu.getPowerInterface().getPowerConsumption(cpu.getPowerInterface().getPowerState()) != -1)
							powerConsumption = cpu.getPowerInterface().getPowerConsumption(cpu.getPowerInterface().getPowerState());
					} catch (NoSuchFieldException e1) {
						powerConsumption = 10;
					}
				}
			} else{
				try {
					if(cpu.getPowerInterface().getPowerConsumption(cpu.getPowerInterface().getPowerState()) != -1)
						powerConsumption = cpu.getPowerInterface().getPowerConsumption(cpu.getPowerInterface().getPowerState());
				} catch (NoSuchFieldException e1) {
					powerConsumption = 0;
				}
			}
			
		}
		if(cpu.getLoadInterface().getRecentUtilization().getValue() != 0.0){
			powerConsumption = powerConsumption * cpu.getLoadInterface().getRecentUtilization().getValue()/100;			
		}
		return powerConsumption;
	}

}
